function [L,U]=LU(A)
% LU factorization
  m=size(A,1);
  assert(size(A,1)==m)
  L=eye(m,m);
  U=zeros(m,m);
  for i=1:m
    Li=L(i,1:i-1).';
    for j=i:m 
      U(i,j)=A(i,j)-dot(Li,U(1:i-1,j));
    end
    Ui=U(1:i-1,i).';
    for j=i+1:m
      L(j,i)=(A(j,i)-dot(L(j,1:i-1),Ui))/U(i,i);
    end
  end
end
